%global pkg be2iscsi

%global kernel_version_min 4.18.0-257.el8

# To pick a specific kernel use `--define "kernel_version 4.18.0-315.el8"`
# Otherwise the latest installed kernel-devel version later than
# %%{kernel_version_min} will be used.

%global kernel_version_latest %({ echo %{kernel_version_min}; rpm --query kernel-devel --queryformat '%%{VERSION}-%%{RELEASE}\\\n' | grep -v "package kernel-devel is not installed"; } | sort -V | sed -e '0,/^%{kernel_version_min}$/d' | tail -n 1)

%if "%{kernel_version_latest}" != ""
%{!?kernel_version:%{expand:%%global kernel_version %{kernel_version_latest}}}
%endif

%global _use_internal_dependency_generator 0

%global debug_package %{nil}

%global __spec_install_post \
  %{?__debug_package:%{__debug_install_post}} \
  %{__arch_install_post} \
  %{__os_install_post} \
  %{__mod_compress_install_post}

%global __mod_compress_install_post find %{buildroot}/lib/modules -type f -name \*.ko -exec xz \{\} \\;


Name:             kmod-%{pkg}
Version:          4.18.0
Release:          326%{?dist}
Summary:          Emulex OneConnectOpen-iSCSI (%{pkg}) driver

License:          GPLv2
URL:              https://www.kernel.org/

Source0:          %{pkg}-%{kernel_version_min}.tar.xz
Patch1:           0001-add-deprecated-ids-be3.patch
Patch2:           0002-add-deprecated-ids-be2.patch

ExclusiveArch:    x86_64 aarch64

BuildRequires:    elfutils-libelf-devel
BuildRequires:    gcc
BuildRequires:    kernel-abi-whitelists
BuildRequires:    kernel-rpm-macros
BuildRequires:    kmod
BuildRequires:    make
BuildRequires:    redhat-rpm-config
BuildRequires:    xz

%{!?kernel_version:
BuildRequires:    kernel-devel >= %{kernel_version_min}
}

%{?kernel_version:
BuildRequires:    kernel-devel = %{kernel_version}

Supplements:      kernel = %{kernel_version}

Requires:         (kernel = %{kernel_version} if kernel)

Provides:         kernel-modules = %{kernel_version}.%{_arch}
}

Requires(post):   /usr/sbin/depmod
Requires(postun): /usr/sbin/depmod

Provides:         %{name} = %{?epoch:%{epoch}:}%{version}-%{release}


%description
This package provides the Emulex OneConnectOpen-iSCSI (%{pkg}) driver. Compared
to the in-kernel driver this driver re-enables support for deprecated
BladeEngine 2 and 3 adapters.

BladeEngine 2 (BE2) devices:
- 0x19A2:0x0212: Emulex BladeEngine 2 10Gb iSCSI Initiator
- 0x19A2:0x0702: Emulex OneConnect OCe10101/OCm10101/OCe10102/OCm10102
- 0x19A2:0x0703: Emulex OneConnect OCe10100

BladeEngine 3 (BE3) devices:
- 0x19A2:0x0222: Emulex BladeEngine 3 iSCSI
- 0x19A2:0x0712: Emulex OneConnect Tomcat iSCSI


%prep
%autosetup -p1 -n %{pkg}-%{kernel_version_min}


%build
pushd src
%{__make} -C /usr/src/kernels/%{kernel_version}.%{_arch} %{?_smp_mflags} M=$PWD modules
popd


%install
%{__install} -D -t %{buildroot}/lib/modules/%{kernel_version}.%{_arch}/extra/drivers/scsi/%{pkg} src/%{pkg}.ko

# Make .ko objects temporarily executable for automatic stripping
find %{buildroot}/lib/modules -type f -name \*.ko -exec chmod u+x \{\} \+


%clean
%{__rm} -rf %{buildroot}


%post
/usr/sbin/depmod -aeF /lib/modules/%{kernel_version}.%{_arch}/System.map %{kernel_version}.%{_arch}


%postun
/usr/sbin/depmod -aeF /lib/modules/%{kernel_version}.%{_arch}/System.map %{kernel_version}.%{_arch}


%files
%defattr(644,root,root,755)
/lib/modules/%{kernel_version}.%{_arch}
%license COPYING


%changelog
* Thu Jul 29 2021 Peter Georg <peter.georg@physik.uni-regensburg.de> - 4.18.0-326
- Rebuild for 4.18.0-326.el8

* Fri Jul 23 2021 Peter Georg <peter.georg@physik.uni-regensburg.de> - 4.18-257
- Initial version
